<template>
	<view class="bill-of-lading-details">
		<view class="top-banner" style="background: url('https://mx.jzeg.cn:9095/appimg/image/banner/loadingbanner.png') no-repeat;background-size: cover;">
			<view class="top-information">
				<view class="cutomer-name">客户:{{ coalDetailsData.customerName || '' }}</view>
				<view class="fild-name">
					<view class="">矿场:{{ coalDetailsData.deptName || '暂无' }}</view>
					<view class="">煤场:{{ coalDetailsData.filedName || '暂无' }}</view>
				</view>
			</view>
			<view class="block-information">
				<view class="block-main">
					<view class="basic">
						<view class="coalName">{{ coalDetailsData.coalName }}</view>
						<!-- <view class="black-block"></view>
						<view class="order-type">{{ coalDetailsData.orderType }}</view> -->
						<view
							class="status-button"
							style="background: url('https://mx.jzeg.cn:9095/appimg/image/banner/statusbutton.png') no-repeat;
										background-size: cover;"
						>
							{{ coalStatus[coalDetailsData.status] }}
						</view>
					</view>
					<view class="time">
						<view class="time-icon"><u-icon name="clock" color="#515151" size="40"></u-icon></view>
						<view class="send-date">{{ coalDetailsData.sendDate }}</view>
					</view>
					<view class="coal-code">提煤单编号:&nbsp;&nbsp;{{ coalDetailsData.code || '' }}</view>
					<view class="order-code">订单编号:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;{{ coalDetailsData.orderCode || '' }}</view>
					<view class="weigh-item">
						<view class="item">
							<view class="concrete" style="background: url('https://mx.jzeg.cn:9095/appimg/image/banner/skin.png') no-repeat;background-size: cover;">皮</view>
							<view class="num">{{ coalDetailsData.skin }}</view>
						</view>
						<view class="item">
							<view class="concrete" style="background: url('https://mx.jzeg.cn:9095/appimg/image/banner/hair.png') no-repeat;background-size: cover;">毛</view>
							<view class="num">{{ coalDetailsData.hair }}</view>
						</view>
						<view class="item">
							<view class="concrete" style="background: url('https://mx.jzeg.cn:9095/appimg/image/banner/clean.png') no-repeat;background-size: cover;">净</view>
							<view class="num">{{ coalDetailsData.clean }}</view>
						</view>
					</view>
				</view>
			</view>
		</view>

		<view class="timeLine">
			<u-steps :current="dayRZ.length - 1" direction="column" dot>
				<u-steps-item :title="item.taskStatusDes" v-for="(item, index) in dayRZ" :key="index"></u-steps-item>
			</u-steps>
		</view>
		<view class="utilsBox">
			<view class="utils_chil utils_chilTop">
				<view class="top-button">
					<u-button text="签到" type="primary" plain @click="arriveClick" shape="circle"></u-button>
					<u-button text="入场申请" type="primary" plain @click="rcsqClick" shape="circle"></u-button>
				</view>
				<view class="bottom-button">
					<u-button text="放空" type="primary" plain @click="evacuation" throttleTime="500" shape="circle"></u-button>
					<u-button text="呼叫客服" type="primary" plain @click="callCustomerService" shape="circle"></u-button>
				</view>
			</view>
		</view>
		<view class="weigh-ability">
			<view class="weigh-button"><u-button text="展示提煤单" @click="showCaolPickUpBill" type="primary" shape="circle"></u-button></view>
			<view class="weigh-button"><u-button text="上磅计量" @click="cengZhongClick" type="primary" shape="circle"></u-button></view>
		</view>
		<view class="evacuationModal">
			<u-modal
				:show="evacuationModalShow"
				:title="evacuationTitle"
				:content="evacuationContent"
				:showCancelButton="true"
				@confirm="evacuationConfirm"
				@cancel="evacuationCancel"
			></u-modal>
		</view>
	</view>
</template>

<script>
import { webSocketUrl } from '@/api/request.js';
import { mapState, mapMutations } from 'vuex';
export default {
	onLoad(value) {
		if (value.orderPlanId && value.yyId) {
			this.orderPlanId = value.orderPlanId;
			this.yyId = value.yyId;
		}
		// wx.startRecord();
	},
	data() {
		return {
			orderPlanId: null,
			yyId: null,
			dayRZ: [],
			coalDetailsData: {}, // 提煤单详情
			currentPageCoalStatus: 0, // 当前页面提煤单状态
			// 获取所在磅房参数
			getWeightHouseObj: {
				deptId: '',
				filedId: '',
				tmId: '',
				tmCode: '',
				carNo: ''
			},
			// 获取入场申请的列表页面参数
			getYuYueDataParams: {
				deptId: '',
				filedId: '',
				sendDate: ''
			},
			// 获取客服openid参数
			getServiceOpenid: {
				deptId: '',
				filedId: ''
			},
			// 客服信息
			serviceInfoObj: {
				openId: null,
				openName: ''
			},
			coalStatus: ['领取', '预约', '签到', '入场', '称皮', '称毛', '离场', '入磅房', '出磅房', '入煤仓', '出煤仓', '放空', '作废', '入场申请', '进入场院'], // 状态
			weighHouseCode: '',
			// 放空弹窗控制变量
			evacuationModalShow: false,
			evacuationTitle: '放空确认',
			evacuationContent: '是否确认放空',
			// 第一次放空参数
			weighData: {
				sceneId: '',
				gateCameraId: '',
				equipmentCode: '',
				weigh: 0,
				sceneInOut: ''
			},
			// 原发信息
			primarySkin: null,
			primaryHair: null,
			primaryClean: null,
			scrollTop: 0
		};
	},
	onShow() {
		this.init();
	},
	computed: {
		...mapState(['globalweigh', 'globalinfraredStatus']),
		name() {
			return uni.getStorageSync('name');
		},
		openid() {
			return uni.getStorageSync('openid');
		},
		// 获取今天日期
		currentDate() {
			let time = new Date();
			let year = time.getFullYear();
			let month = time.getMonth() + 1;
			month = month < 10 ? '0' + month : month;
			let date = time.getDate();
			date = date < 10 ? '0' + date : date;
			return `${year}-${month}-${date}`;
		}
	},
	methods: {
		init() {
			this.coalDayPage(); //获取日志
			this.getTakeCoal(); //获取提煤单详情
			this.getgetService(); //获取客服
		},
		// 获取客服openid
		getgetService() {
			this.$reqGet('getCallOutList', this.getServiceOpenid).then(res => {
				console.log(res, '客服openid');
				if (res.code != 0) {
					this.$u.toast('获取客服信息失败');
				} else {
					if (res.data.length > 0) {
						this.serviceInfoObj.openId = res.data[0].openId;
						this.serviceInfoObj.openName = res.data[0].openName;
						uni.setStorageSync('customeropenId', this.serviceInfoObj.openId);
						uni.setStorageSync('customerName', this.serviceInfoObj.openName);
					}
				}
			});
		},
		// 获取提煤单详情
		getTakeCoal() {
			this.$reqGet('getTakeCoal', { takeCoalId: this.orderPlanId }).then(res => {
				if (res.code == 0) {
					console.log(res, '提煤单详情');
					this.coalDetailsData = res.data;
					// 获取所在磅房参数赋值
					this.getWeightHouseObj.deptId = this.coalDetailsData.deptId;
					this.getWeightHouseObj.filedId = this.coalDetailsData.filedId;
					this.getWeightHouseObj.tmId = this.coalDetailsData.id;
					this.getWeightHouseObj.tmCode = this.coalDetailsData.code;
					this.getWeightHouseObj.carNo = this.coalDetailsData.carNo;
					// 获取入场申请操作后的预约列表的参数
					this.getYuYueDataParams.deptId = this.coalDetailsData.deptId;
					this.getYuYueDataParams.filedId = this.coalDetailsData.filedId;
					this.getYuYueDataParams.sendDate = this.coalDetailsData.sendDate;
					// 获取客服openId参数赋值
					this.getServiceOpenid.deptId = this.coalDetailsData.deptId;
					this.getServiceOpenid.filedId = this.coalDetailsData.filedId;
					// 获取提煤单状态
					this.currentPageCoalStatus = this.coalDetailsData.status;
					// 获取原发信息
					this.primarySkin = this.coalDetailsData.skinTwo;
					this.primaryHair = this.coalDetailsData.hairTwo;
					this.primaryClean = this.coalDetailsData.cleanTwo;
				}
			});
		},
		// 日志查询
		coalDayPage() {
			this.$reqGet('coalDayPage', { id: this.orderPlanId }).then(res => {
				if (res.code == 0) {
					this.dayRZ = res.data;
					this.dayRZ = this.dayRZ.map(v => {
						let slicedate = v.taskStatusDes.slice(0, 10);
						if (slicedate == this.currentDate) {
							return {
								...v,
								taskStatusDes: v.taskStatusDes.slice(10)
							};
						}
					});
				}
			});
		},
		// 展示提煤单详情
		showCaolPickUpBill() {
			uni.navigateTo({
				url: `/pages/driver-page/driver-index/bill-of-lading-details/coal-pick-up-bill/coal-pick-up-bill?orderPlanId=${this.orderPlanId}`
			});
		},
		// 签到
		arriveClick() {
			uni.navigateTo({
				url: `/pages/driver-page/driver-index/bill-of-lading-details/punchTheClock/punchTheClock?orderPlanId=${this.orderPlanId}&coalStatus=${
					this.currentPageCoalStatus
				}&tmId=${this.getWeightHouseObj.tmId}`
			});
		},
		// 入场申请
		rcsqClick() {
			uni.navigateTo({
				url: `/pages/driver-page/appointment/appointment?type=入场申请&takeCoalId=${this.orderPlanId}&yyId=${this.yyId}&filedId=${this.getYuYueDataParams.filedId}&deptId=${
					this.getYuYueDataParams.deptId
				}&sendDate=${this.getYuYueDataParams.sendDate}`
			});
		},
		// 呼叫客服
		callCustomerService() {
			// if (!this.serviceInfoObj.openId) {
			// this.$u.toast('无客服信息');
			// }
			wx.getSetting({
				success(res) {
					console.log('授权success', res);
					if (!res.authSetting['scope.camera'] || !res.authSetting['scope.record']) {
						if (!res.authSetting['scope.camera']) {
							uni.showToast({
								title: '无相机权限'
							});
						} else if (!res.authSetting['scope.record']) {
							uni.showToast({
								title: '无麦克风权限'
							});
						}
					} else {
						wx.join1v1Chat({
							caller: { nickname: uni.getStorageSync('name'), openid: uni.getStorageSync('openid') },
							listener: { nickname: uni.getStorageSync('customerName'), openid: uni.getStorageSync('customeropenId') }, // 这里的openid是fyy的，充当固定的客服openid
							backgroundType: 2,
							roomType: 'voice',
							success() {
								console.log('一对一成功');
							},
							fail(err) {
								console.log('一对一失败', err);
							}
						});
					}
				},
				fail() {
					console.log('获取失败');
				}
			});
		},
		calling() {
			// wx.join1v1Chat({
			// 	caller: { nickname: this.name, openid: this.openid }, //oZjXk5RRmbroAfl1m5aZ6hRNvqh4
			// 	listener: { nickname: this.serviceInfoObj.openName, openid: 'orutI5YT0yEvARVngdsTmBpisWmw' }, // 这里的openid是fyy的，充当固定的客服openid
			// 	backgroundType: 2,
			// 	roomType: 'voice'
			// });
		},
		// 称重
		cengZhongClick() {
			this.$reqGet('getWeighHouse', this.getWeightHouseObj).then(res => {
				console.log(res, '获取磅房');
				if (res.code == 0) {
					this.weighData.sceneId = res.data.id;
					this.weighData.gateCameraId = res.data.lastEquipmentId;
					this.weighData.equipmentCode = res.data.lastEquipmentCode;
					this.weighData.sceneInOut = res.data.sceneInOut;
					this.weighHouseCode = res.data.code;
					uni.navigateTo({
						url: `/pages/driver-page/driver-index/bill-of-lading-details/weighingDevice/weighingDevice?takeCoalId=${this.orderPlanId}&sceneId=${
							res.data.id
						}&gateCameraId=${res.data.lastEquipmentId}&gateCameraCode=${res.data.lastEquipmentCode}&weighHouseCode=${res.data.code}&primarySkin=${
							this.primarySkin
						}&primaryHair=${this.primaryHair}&psrimaryClean=${this.primaryClean}&sceneInOut=${res.data.sceneInOut}`
					});
				} else {
					this.$u.toast('未在磅房，请前往磅房后再试！！');
				}
			});
		},
		// 放空
		evacuation() {
			this.evacuationModalShow = true;
		},
		// 放空弹窗确认
		evacuationConfirm() {
			this.weighData = {
				...this.weighData,
				weigh: this.globalweigh
			};
			let mix = Object.assign(this.weighData, this.getWeightHouseObj);
			this.$reqPost('getOneEvacuation', mix, 'json').then(res => {
				console.log(res, '第一次放空');
				if (res.code == 0) {
					this.$u.toast('操作成功');
					this.evacuationModalShow = false;
				} else {
					this.$u.toast('操作失败，请稍后重试');
					this.evacuationModalShow = false;
				}
			});
		},
		// 放空弹窗取消
		evacuationCancel() {
			this.evacuationModalShow = false;
		}
	}
};
</script>

<style lang="scss" scoped>
/deep/.u-steps {
	.u-steps-item {
		.u-steps-item__content {
			.u-text {
				.u-text__value {
					font-size: 31rpx !important;
					font-weight: 300;
					color: #303030;
				}
			}
		}
	}
}
@mixin flex {
	display: flex;
	justify-content: space-between;
	align-items: center;
}
::v-deep.bill-of-lading-details {
	width: 100%;
	height: 100vh;
	margin: 0 auto;
	display: flex;
	flex-direction: column;
	.top-banner {
		width: 100%;
		height: 346rpx;
		.top-information {
			width: 94%;
			margin: 0 auto;
			height: vww(52);
			@include flex position: relative;
			flex-direction: column;
			justify-content: space-between;
			align-items: flex-start;
			top: vww(25);
			color: #ffffff;
			font-size: 31rpx;
			font-weight: 300;
			.fild-name {
				@include flex;
				justify-content: space-between;
				width: 100%;
				view {
					min-width: 296rpx;
				}
			}
		}
		.block-information {
			width: 690rpx;
			height: 396rpx;
			margin: vww(40) auto;
			background: #ffffff;
			box-shadow: 4rpx 6rpx 51rpx 0rpx rgba(73, 120, 240, 0.11);
			border-radius: 20rpx;
			position: relative;
			font-size: 30rpx;
			font-weight: 300;
			color: #303030;
			overflow: hidden;
			.block-main {
				@include flex width: 94%;
				height: 336rpx;
				margin: vww(18) vww(7) vww(11) vww(17);
				flex-direction: column;
				justify-content: space-between;
				align-items: flex-start;
			}
			.status-button {
				width: vww(71);
				height: vww(36);
				text-align: center;
				line-height: vww(33);
				font-size: 28rpx;
				font-weight: 300;
				position: absolute;
				right: vww(10);
				color: #fff;
			}
			.basic {
				width: 100%;
				height: vww(15);
				@include flex;
				justify-content: flex-start;
				.coalName,
				.order-type {
					width: 45%;
					height: 30rpx;
					font-size: 30rpx;
					font-weight: 300;
					color: #515151;
					position: relative;
				}
				.black-block {
					width: 2rpx;
					height: 30rpx;
					background: #515151;
					position: relative;
					top: vww(2);
				}
			}
			.time {
				width: 35%;
				height: vww(12);
				display: flex;
				justify-content: flex-start;
				.send-date {
					width: 148rpx;
					height: 24rpx;
					margin-left: vww(14);
					font-size: 28rpx;
					font-weight: 300;
					color: #515151;
				}
			}
			.coal-code,
			.order-code {
				width: 100%;
				height: 24rpx;
				font-size: 28rpx;
				font-weight: 300;
				color: #7d7d7d;
			}
			.weigh-item {
				width: 100%;
				height: vww(36);
				@include flex;
				justify-content: space-around;
				.item {
					min-width: vww(50);
					height: vww(45);
					font-size: 21rpx;
					font-weight: 400;
					color: #ffffff;
					text-align: center;
					line-height: vww(30);
					@include flex;
					.concrete {
						width: vww(36);
						height: vww(36);
					}
					.num {
						font-size: 40rpx;
						font-weight: 300;
						color: #303030;
					}
				}
			}
		}
	}
	.timeLine {
		height: 40%;
		margin: vww(20);
		position: relative;
		top: vww(120);
		overflow-y: overlay;
		padding: vww(20);
		.u-steps {
			.u-steps-item {
				padding-bottom: vww(35);
				.u-steps-item__wrapper {
					.u-steps-item__wrapper__dot {
						background: linear-gradient(-29deg, #426cff 0%, #7991ff 100%);
						box-shadow: 2rpx 7rpx 10rpx 0rpx rgba(172, 172, 172, 0.64);
					}
				}
				.u-steps-item__line {
					height: vww(52) !important;
					background: #e9e6ea !important;
				}
			}
		}
	}
	.utilsBox {
		width: 94%;
		margin: 0 auto;
		position: relative;
		top: vww(80);
		.utils_chil {
			width: 100%;
			margin: 0 auto;
			.top-button,
			.bottom-button {
				width: 100%;
				height: vww(47);
				@include flex;
				.u-button {
					width: 40%;
					height: 60rpx;
					font-size: 28rpx;
					font-weight: 300;
					color: #497bfb;
					border: 2px solid #3b56eb;
				}
			}
		}
	}
	.weigh-ability {
		width: 631rpx;
		height: vww(100);
		margin: vww(80) auto;
		margin-bottom: vww(10);
		@include flex;
		flex-direction: column;
		.weigh-button {
			width: 631rpx;
			height: vww(89);
			.u-button {
				font-size: 28rpx;
				font-weight: 300;
				color: #ffffff;
				background: #497bfb;
				letter-spacing: 4rpx;
				border-radius: 37rpx 37rpx 37rpx 37rpx;
				box-shadow: 2rpx 3rpx 13rpx 0rpx rgba(43, 98, 239, 0.5), 0rpx 0rpx 9rpx 0rpx rgba(247, 250, 253, 0.29);
			}
		}
	}
}
</style>
